<?php

/**
 * @file
 * Contains \Drupal\civicrm_contact_distance_search\Form\CivicrmContactDistanceSearchAdmin.
 */

namespace Drupal\civicrm_contact_distance_search\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class CivicrmContactDistanceSearchAdmin extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'civicrm_contact_distance_search_admin';
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $config = $this->config('civicrm_contact_distance_search.settings');

    foreach (Element::children($form) as $variable) {
      $config->set($variable, $form_state->getValue($form[$variable]['#parents']));
    }
    $config->save();

    if (method_exists($this, '_submitForm')) {
      $this->_submitForm($form, $form_state);
    }

    parent::submitForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['civicrm_contact_distance_search.settings'];
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $form = [];

    $form['civicrm_contact_distance_search_googleapi'] = [
      '#type' => 'textfield',
      '#title' => t('Google Maps API Key'),
      '#default_value' => \Drupal::config('civicrm_contact_distance_search.settings')->get('civicrm_contact_distance_search_googleapi'),
      '#size' => 100,
      '#description' => t("Add the Google Maps API Key here for civicrm contact distance search"),
      '#required' => TRUE,
    ];


    $form['is_find_postcode_enabled'] = array(
      '#type' => 'checkbox',
      '#title' => t('Enable find nearest postcode feature ?'),
      '#default_value' => \Drupal::config('civicrm_contact_distance_search.settings')->get('is_find_postcode_enabled'),
      '#description' => t("Enable this for finding nearest postcode functionality"),
      '#required' => FALSE,
    );

    $form['is_gmap_enabled'] = array(
      '#type' => 'checkbox',
      '#title' => t('Enable GoogleMap index ?'),
      '#default_value' => \Drupal::config('civicrm_contact_distance_search.settings')->get('is_gmap_enabled'),
      '#description' => t("Enable this for marking contacts in GoogleMap"),
      '#required' => FALSE,
    );

    return parent::buildForm($form, $form_state);
  }

}
?>
